import { Any } from "./google/protobuf/any";
export declare const protobufPackage = "pocketjs";
export interface ProtoStdTx {
    msg: Any | undefined;
    fee: Coin[];
    signature: ProtoStdSignature | undefined;
    memo: string;
    entropy: number;
}
export interface ProtoStdSignature {
    publicKey: Uint8Array;
    Signature: Uint8Array;
}
export interface StdSignDoc {
    ChainID: string;
    fee: Uint8Array;
    memo: string;
    msg: Uint8Array;
    entropy: number;
}
export interface Coin {
    denom: string;
    amount: string;
}
/**
 * DecCoin defines a token with a denomination and a decimal amount.
 *
 * NOTE: The amount field is an Dec which implements the custom method
 * signatures required by gogoproto.
 */
export interface DecCoin {
    denom: string;
    amount: string;
}
export interface MsgProtoStake {
    pubKey: Uint8Array;
    chains: string[];
    value: string;
}
export interface MsgBeginUnstake {
    Address: Uint8Array;
}
export interface MsgUnjail {
    AppAddr: Uint8Array;
}
export interface MsgProtoNodeStake {
    Publickey: Uint8Array;
    Chains: string[];
    value: string;
    ServiceUrl: string;
}
export interface MsgBeginNodeUnstake {
    Address: Uint8Array;
}
export interface MsgNodeUnjail {
    ValidatorAddr: Uint8Array;
}
export interface MsgSend {
    FromAddress: Uint8Array;
    ToAddress: Uint8Array;
    amount: string;
}
export declare const ProtoStdTx: {
    encode(message: ProtoStdTx, writer?: Writer): Writer;
    decode(input: any, length?: number): ProtoStdTx;
    fromJSON(object: any): ProtoStdTx;
    fromPartial(object: DeepPartial<ProtoStdTx>): ProtoStdTx;
    toJSON(message: ProtoStdTx): unknown;
};
export declare const ProtoStdSignature: {
    encode(message: ProtoStdSignature, writer?: Writer): Writer;
    decode(input: any, length?: number): ProtoStdSignature;
    fromJSON(object: any): ProtoStdSignature;
    fromPartial(object: DeepPartial<ProtoStdSignature>): ProtoStdSignature;
    toJSON(message: ProtoStdSignature): unknown;
};
export declare const StdSignDoc: {
    encode(message: StdSignDoc, writer?: Writer): Writer;
    decode(input: any, length?: number): StdSignDoc;
    fromJSON(object: any): StdSignDoc;
    fromPartial(object: DeepPartial<StdSignDoc>): StdSignDoc;
    toJSON(message: StdSignDoc): unknown;
};
export declare const Coin: {
    encode(message: Coin, writer?: Writer): Writer;
    decode(input: any, length?: number): Coin;
    fromJSON(object: any): Coin;
    fromPartial(object: DeepPartial<Coin>): Coin;
    toJSON(message: Coin): unknown;
};
export declare const DecCoin: {
    encode(message: DecCoin, writer?: Writer): Writer;
    decode(input: any, length?: number): DecCoin;
    fromJSON(object: any): DecCoin;
    fromPartial(object: DeepPartial<DecCoin>): DecCoin;
    toJSON(message: DecCoin): unknown;
};
export declare const MsgProtoStake: {
    encode(message: MsgProtoStake, writer?: Writer): Writer;
    decode(input: any, length?: number): MsgProtoStake;
    fromJSON(object: any): MsgProtoStake;
    fromPartial(object: DeepPartial<MsgProtoStake>): MsgProtoStake;
    toJSON(message: MsgProtoStake): unknown;
};
export declare const MsgBeginUnstake: {
    encode(message: MsgBeginUnstake, writer?: Writer): Writer;
    decode(input: any, length?: number): MsgBeginUnstake;
    fromJSON(object: any): MsgBeginUnstake;
    fromPartial(object: DeepPartial<MsgBeginUnstake>): MsgBeginUnstake;
    toJSON(message: MsgBeginUnstake): unknown;
};
export declare const MsgUnjail: {
    encode(message: MsgUnjail, writer?: Writer): Writer;
    decode(input: any, length?: number): MsgUnjail;
    fromJSON(object: any): MsgUnjail;
    fromPartial(object: DeepPartial<MsgUnjail>): MsgUnjail;
    toJSON(message: MsgUnjail): unknown;
};
export declare const MsgProtoNodeStake: {
    encode(message: MsgProtoNodeStake, writer?: Writer): Writer;
    decode(input: any, length?: number): MsgProtoNodeStake;
    fromJSON(object: any): MsgProtoNodeStake;
    fromPartial(object: DeepPartial<MsgProtoNodeStake>): MsgProtoNodeStake;
    toJSON(message: MsgProtoNodeStake): unknown;
};
export declare const MsgBeginNodeUnstake: {
    encode(message: MsgBeginNodeUnstake, writer?: Writer): Writer;
    decode(input: any, length?: number): MsgBeginNodeUnstake;
    fromJSON(object: any): MsgBeginNodeUnstake;
    fromPartial(object: DeepPartial<MsgBeginNodeUnstake>): MsgBeginNodeUnstake;
    toJSON(message: MsgBeginNodeUnstake): unknown;
};
export declare const MsgNodeUnjail: {
    encode(message: MsgNodeUnjail, writer?: Writer): Writer;
    decode(input: any, length?: number): MsgNodeUnjail;
    fromJSON(object: any): MsgNodeUnjail;
    fromPartial(object: DeepPartial<MsgNodeUnjail>): MsgNodeUnjail;
    toJSON(message: MsgNodeUnjail): unknown;
};
export declare const MsgSend: {
    encode(message: MsgSend, writer?: Writer): Writer;
    decode(input: any, length?: number): MsgSend;
    fromJSON(object: any): MsgSend;
    fromPartial(object: DeepPartial<MsgSend>): MsgSend;
    toJSON(message: MsgSend): unknown;
};
declare type Builtin = Date | Function | Uint8Array | string | number | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
//# sourceMappingURL=tx-signer.d.ts.map